/***********************************************************************/
/*                                                                     */
/*  FILE        :SH7125_ECU.c                                          */
/*  DATE        :Sun, Jan 16, 2011                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :SH7125                                                */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.16).    */
/*                                                                     */
/***********************************************************************/
                  


//#include "typedefine.h"
#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif

#include "iodefine.h"
#include "ecu_init.h"
#include "rotation_speed.h"
#include "intervaltimer.h"
#include "sci.h"
#include "injection.h"
#include "speed.h"
#include "ignition.h"
#include "iscv.h"
#include "knock.h"

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif


// PCƒʐM
void monitor(void)
{
	unsigned char a,b;
	unsigned int temp;
	
	a=getch();
	switch(a)
	{
		// Xe[^XM
		// [STATUS 2byte][] 2byte][zC 1byte][˃}bvCfbNX 4byte]
		// [ˎ 2byte][_Ύ 1byte][O2 1byte][mbN 1byte][ 1byte][zC 1byte][ 1byte]
		// [SPEED 1byte][DISTANCE 4byte]
		// ܂ 22byte *10bit=220bit 9600bps0.03b炢
		// 19200bps0.01b炢
		case 0x01:
		case 0x31:
			putch((STATUS>>8) & 0xFF);	//  0 STATUS 
			putch(STATUS & 0xFF);		//  1 STATUS 
			putch((RPM>>8) & 0xFF);		//  2 ] 
			putch(RPM & 0xFF);			//  3 ]  [RPM]
			putch((AIR>>8) & 0xFF);		//  4 zC
			putch(INJIDX_A1);			//  5 A1 ˃}bvCfbNX
			putch(INJIDX_A2);			//  6 A2 ˃}bvCfbNX
			putch(INJIDX_R1);			//  7 R1 ˃}bvCfbNX
			putch(INJIDX_R2);			//  8 R2 ˃}bvCfbNX
			putch((MONINJ>>8) & 0xFF);	//  9 CWFN^Jَ 
			putch(MONINJ & 0xFF);		// 10 CWFN^Jَ  *10[us]
			putch(MONIGN);				// 11 _Ύ [BTDCx]
			putch((O2>>8) & 0xFF);		// 12 O2ZT[
			putch(KNOCK);				// 13 mbNZT[
			KNOCK=0;	// mbNZT[̍őlZbg
			putch(WATER_TEMP);			// 14 
			putch(AIR_TEMP);			// 15 zC
			putch(OIL_TEMP);			// 16 
			putch(ISCVSTEP);			// 17 ISCVJx
			putch(SPEED);				// 18 x[km/h]
			temp=getdistance();
			putch(temp>>(8*3) & 0xFF);	// 19 ECUZbg̑s[m]
			putch(temp>>(8*2) & 0xFF);	// 20
			putch(temp>>(8*1) & 0xFF);	// 21
			putch(temp        & 0xFF);	// 22
		break;

		// [CWFN^ݐϊJَ[us] 8byte]
		case 0x02:
			putch((INJACCUM>>(8*7)) & 0xFF);
			putch((INJACCUM>>(8*6)) & 0xFF);
			putch((INJACCUM>>(8*5)) & 0xFF);
			putch((INJACCUM>>(8*4)) & 0xFF);
			putch((INJACCUM>>(8*3)) & 0xFF);
			putch((INJACCUM>>(8*2)) & 0xFF);
			putch((INJACCUM>>(8*1)) & 0xFF);
			putch( INJACCUM         & 0xFF);
		break;

		// [ˊ{}bv 16*25*2=800byte] 19200bps0.5b炢
		case 0x03:
			for(a=0;a<16;a++)
			{
				for(b=0;b<25;b++)
				{
					putch((INJ_MAP[a][b]>>8) & 0xFF);
					putch( INJ_MAP[a][b]     & 0xFF);
				}
			}
		break;
		
		// [˕␳}bv 16*25*1=400byte]
		case 0x04:
			for(a=0;a<16;a++)
			{
				for(b=0;b<25;b++)
				{
					putch(INJCOMP_MAP[a][b]);
				}
			}
		break;
		
		// [_Ί{}bv 16*25*1=400byte]
		case 0x05:
			for(a=0;a<16;a++)
			{
				for(b=0;b<25;b++)
				{
					putch(IGN_MAP[a][b]);
				}
			}
		break;
		
		// [בʕ␳ʃ}bv 16*25*1=400byte]
		case 0x06:
			for(a=0;a<16;a++)
			{
				for(b=0;b<25;b++)
				{
					putch(INJCORR_MAP[a][b]);
				}
			}
		break;

		////////////////////////////////////////////////////////////////////////////////
		// ݃R}h

		// RtB[hobN␳֎~tONA
		case 0x40:
			putch(a);	// R}h̃GR[Ԃȉꍇ0x40Ԃj

			STATUS&=~SO2DIS;	// RtB[hobN␳֎~tONA
			putch(0);
		break;

		// RtB[hobN␳֎~tOZbg
		case 0x41:
			putch(a);	// R}h̃GR[Ԃ

			STATUS|=SO2DIS;	// RtB[hobN␳֎~tOZbg
			putch(1);
		break;
		
		// ˊ{}bv 1000ȏ
		case 0x42:
			putch(a);

			a=getch();
			b=getch();
			temp=((unsigned short)getch()<<8)&0xFF00;
			temp|=getch()&0xFF;
			if((a<16) && (b<25))
			{
				if(temp>1000)INJ_MAP[a][b]=temp;
		
				putch(INJ_MAP[a][b]>>8);
				putch(INJ_MAP[a][b]&0xFF);
			}
		break;

		// ˕␳}bv
		case 0x43:
			putch(a);

			a=getch();
			b=getch();
			temp=getch();
			if((a<16) && (b<25))
			{
				INJCOMP_MAP[a][b]=temp;
				putch(INJCOMP_MAP[a][b]);
			}
		break;

		// _Ί{}bv
		case 0x44:
			putch(a);

			a=getch();
			b=getch();
			temp=getch();
			if((a<16) && (b<25))
			{
				if(temp<60) IGN_MAP[a][b]=temp;
				putch(IGN_MAP[a][b]);
			}
		break;

		// ˊ{}bv
		case 0x45:
			putch(a);
			inj_map_init();
		break;

		// ˕␳}bv
		case 0x46:
			putch(a);
			injcomp_map_init();
		break;

		// _΃}bv
		case 0x47:
			putch(a);
			ignmap_init();
		break;
		
		// xZT[ُtONA
		case 0x48:
			putch(a);
			STATUS&=~SAIRERR;
			STATUS&=~SWATERERR;
		break;
		
		// ̂ق̃p[^[STATUS
		case 0x49:
			putch(a);
			parameter_init();
		break;

		// CWFN^ݐϊJَԃNA
		case 0x4A:
			putch(a);
			INJACCUM=0;
		break;

		// sZbg
		case 0x4B:
			putch(a);
			DISTANCE=0;
		break;

		//extern volatile unsigned short REVLIMIT;		// u~bg
		case 0x4C:
			putch(a);
			temp=((unsigned short)getch()<<8)&0xFF00;
			temp|=getch()&0xFF;
			if((temp>4000)&&(temp<9000)) REVLIMIT=temp;
			putch(REVLIMIT>>8);
			putch(REVLIMIT&0xFF);
		break;

		//extern volatile unsigned short REVLIMIT_CLR;	// u~bgA˂ĊJ]
		case 0x4D:
			putch(a);
			temp=(getch()<<8)&0xFF00;
			temp|=getch()&0xFF;
			if((temp>4000)&&(temp<9000)) REVLIMIT_CLR=temp;
			putch(REVLIMIT_CLR>>8);
			putch(REVLIMIT_CLR&0xFF);
		break;

		//extern volatile unsigned short REV_FUELCUT;		// GWu[LRJbg]
		case 0x4E:
			putch(a);
			temp=((unsigned short)getch()<<8)&0xFF00;
			temp|=getch()&0xFF;
			if((temp>1000)&&(temp<9000)) REV_FUELCUT=temp;
			putch(REV_FUELCUT>>8);
			putch(REV_FUELCUT&0xFF);
		break;

		//extern volatile unsigned short IDL_RPM;			// AChOڕW]
		case 0x4F:
			putch(a);
			temp=((unsigned short)getch()<<8)&0xFF00;
			temp|=getch()&0xFF;
			if((temp>800)&&(temp<2000)) IDL_RPM=temp;
			putch(IDL_RPM>>8);
			putch(IDL_RPM&0xFF);
		break;

		//extern volatile unsigned short LOAD_RPM;		// ׁE⎞AChOڕW]
		case 0x50:
			putch(a);
			temp=((unsigned short)getch()<<8)&0xFF00;
			temp|=getch()&0xFF;
			if((temp>800)&&(temp<2000)) LOAD_RPM=temp;
			putch(LOAD_RPM>>8);
			putch(LOAD_RPM&0xFF);
		break;

		//extern volatile unsigned char DWELL;			// hG^C[ms]*10  3.2ms Ȃ 32Zbg
		case 0x51:
			putch(a);
			temp=getch();
			if(temp>20) DWELL=temp;
			putch(DWELL);
		break;

		//extern volatile unsigned char INJRESUME;		// RJbg񕜎̑ʕ␳(%)
		case 0x52:
			putch(a);
			temp=getch();
			if(temp>1) INJRESUME=temp;
			putch(INJRESUME);
		break;

		//extern volatile unsigned char ACCELCOMP_VAL;	// ␳(%)
		case 0x53:
			putch(a);
			temp=getch();
			if(temp>99) ACCELCOMP_VAL=temp;
			putch(ACCELCOMP_VAL);
		break;

		//extern volatile unsigned char ACCELCOMP_TH;		// zCʂ̕ω̒l␳s
		case 0x54:
			putch(a);
			temp=getch();
			if((temp>0)&&(temp<50)) ACCELCOMP_TH=temp;
			putch(ACCELCOMP_TH);
		break;
		
		//extern volatile unsigned char INJRESUMEISCV;	// RJbg񕜎ISCVJx(%)
		case 0x55:
			putch(a);
			temp=getch();
			//if((temp>0)&&(temp<101)) INJRESUMEISCV=temp;
			//putch(INJRESUMEISCV);
			putch(0);
		break;
		
		//unsigned char ISCVMIN;	// ISCVŏ fB[eB[ ʓdԂ45`78%
		case 0x56:
			putch(a);
			temp=getch();
			if((temp>9)&&(temp<50)) ISCVMIN=temp;
			putch(ISCVMIN);
		break;

		//unsigned char ISCVMAX;	// ISCVő
		case 0x57:
			putch(a);
			temp=getch();
			if((temp>49)&&(temp<90)) ISCVMAX=temp;
			putch(ISCVMAX);
		break;

		//unsigned char ISCVDEF;	// ISCVʒu
		case 0x58:
			putch(a);
			temp=getch();
			if((temp>0)&&(temp<101)) ISCVDEF=temp;
			putch(ISCVDEF);
		break;

		// unsigned char ACCELCOMP_POW;	// o͋R␳(%) 100ŕ␳Ȃ
		case 0x59:
			putch(a);
			temp=getch();
			if(temp>99) ACCELCOMP_POW=temp;
			putch(ACCELCOMP_POW);
		break;

		// בʕ␳ʃ}bv
		case 0x5A:
			putch(a);

			a=getch();
			b=getch();
			temp=getch();
			if((a<16) && (b<25))
			{
				INJCORR_MAP[a][b]=temp;
				putch(INJCORR_MAP[a][b]);
			}
		break;

		// בʕ␳ʃ}bv
		case 0x5B:
			putch(a);
			injcorr_map_init();
		break;
		
		// ڑeXg
		case 0xAA:
		case 0x30:	//'0'
			putch(a);	// ڑeXg GR[Ԃ
		break;
	}
}

void main(void)
{
	unsigned int temp;		// int32bit
	//WDTclr();
	ecu_init();
	injcomp_map_init();	// R␳}bviZbg̎BX[vł͏Ȃj
	
	// eXgŊ荞݂֎~Ƃɂ̃RgOėD惌x0ɂ΂悢
	//INTC.IPRA.BIT._IRQ0=3;		// NNAONe 荞݃xZbg
	//INTC.IPRA.BIT._IRQ3=1;		// _ΊmFIGf荞݃xZbg
	//INTC.IPRD.BIT._MTU21G=4;	// ]vCvbgLv`荞ݗD惌x
	//INTC.IPRD.BIT._MTU21C=1;	// ]vI[o[t[荞ݗD惌x
	//INTC.IPRE.BIT._MTU22G=1;	// ԑvCvbgLv`荞ݗD惌x
	//INTC.IPRE.BIT._MTU22C=1;	// ԑvI[o[t[荞ݗD惌x
	//INTC.IPRF.BIT._MTU24G=1;	// mbNZT[ RyA}b`荞ݗD惌x
	//INTC.IPRF.BIT._MTU25=1;	// ˁEC^[o^C}[RyA}b`荞ݗD惌x
	//INTC.IPRJ.BIT._CMT0=5;	// _ CMT RyA}b`荞ݗD惌x
	//INTC.IPRJ.BIT._CMT1=5;	// _ CMT RyA}b`荞ݗD惌x
	//INTC.IPRK.BIT._AD01=1;	// mbNZT[ ADϊ荞ݗD惌x

	//STATUS|=SO2DIS;	// RtB[hobN␳֎~tOĂ
	
	//for(temp=5000000; temp!=0; temp--) WDTclr();
	puts("NA6CE ECU SH7125\r\nhttp://kyoutan.jpn.org/car/\r\n");
	
	while(1)
	{
		WDTclr();
		monitor();
		//if(kbhit()==1)putch(getch());
		/*
		for(temp=5000000; temp!=0; temp--);
		puts("RPM:");
		putint(RPM);
		puts(" AIR:");
		putint(AIR>>8);
		puts(" TIME:");
		putint(TIMER);
		puts(" WATER TEMP:");
		putint(WATER_TEMP);
		puts(" AIR TEMP:");
		putint(AIR_TEMP);
		puts(" STATUS:");
		putint(STATUS);
		putch(' ');
		putint(DEBUG1);
		putch(' ');
		putint(DEBUG2);
		puts("\r\n");
		*/
	}
}

#ifdef __cplusplus
void abort(void)
{

}
#endif
